# Method: projects.draft.write

- [HTTP request](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.PATH_PARAMETERS)
- [Request body](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.request_body)
  - [JSON representation](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.request_body.SCHEMA_REPRESENTATION)
- [Response body](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.response_body)
  - [JSON representation](https://developers.google.com/assistant/actions/api/reference/rest/v2/projects.draft/write#body.Draft.SCHEMA_REPRESENTATION)

Updates the project draft based on the model.

### HTTP request

`POST https://actions.googleapis.com/v2/{parent=projects/*}/draft:write`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The parent resource name in the format `projects/{project}`. The `{project}` is the cloud project ID associated with the project. |

### Request body

The request body contains data with the following structure:

| JSON representation ||
|---|---|
| ``` { "files": { object (`https://developers.google.com/assistant/actions/api/reference/rest/v2/Files`) } } ``` |

| Fields ||
|---|---|
| `files` | ``object (`https://developers.google.com/assistant/actions/api/reference/rest/v2/Files`)`` Required. List of files sent to the server at a time. This is a list of config files or data files. 1. The first request must be a ConfigFiles. 2. The first request must have a ConfigFile with 'settings'. 3. The first request must have a ConfigFile with 'manifest'. 4. The webhook ConfigFile corresponding to inline cloud function must be streamed before the DataFile corresponding to its source code. |

### Response body

If successful, the response body contains data with the following structure:
Definition of draft resource.

| JSON representation ||
|---|---|
| ``` { "name": string, "validationResults": { object (`https://developers.google.com/assistant/actions/api/reference/rest/v2/ValidationResults`) } } ``` |

| Fields ||
|---|---|
| `name` | `string` The unique identifier of the draft in the following format. `projects/{project}/draft` |
| `validationResults` | ``object (`https://developers.google.com/assistant/actions/api/reference/rest/v2/ValidationResults`)`` Validation results associated with the project draft content. Note that draft.write updates the draft despite the warnings as warnings are not draft blocking. |